//+------------------------------------------------------------------+
//|                                                  TradeSystem.mq4 |
//+------------------------------------------------------------------+

#include <Traling.mqh>
#include <stderror.mqh>
#include <stdlib.mqh>

double MinLot=0.01; //  ,       

void ProcessAvg(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
//	double lots = AccountFreeMargin()*0.01*0.0001; //  = 0.1  100000
	double lots = AccountFreeMargin()*0.01*0.0001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
//----      
	cbuy = CountAllOrders(OP_BUY, SysID); csell = CountAllOrders(OP_SELL, SysID); 
	//----  LIMIT
	if (cbuy<=0) {	total = CreatTicketArray(OP_BUYLIMIT, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrBuy);}
	if (csell<=0) { total = CreatTicketArray(OP_SELLLIMIT, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrSell);}
	
//----    
	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
   if(Signal == OP_BUY)
		{
			if (cbuy>0)	return; //----      ,    
			//----    LIMIT
			total = CreatTicketArray(OP_BUYLIMIT, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Green);
			//----    BUY
			ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-5000*Point, Ask+SysPar[SysID][_TP]*Point, "BUY", SysID, 0, ClrBuy);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return; 
		}
//-----    
	if(Signal == OP_SELL)
		{
			if (csell>0)	return; //----      ,    
			total = CreatTicketArray(OP_SELLLIMIT, SysID);	for (i=1; i<=total; i++)	OrderDelete(Ticket[i], Red);
			ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+5000*Point, Bid-SysPar[SysID][_TP]*Point, "SELL", SysID, 0, ClrSell);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return;
     }
//----
}

void ProcessTurn(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
	double lots = AccountFreeMargin()*0.01*0.0001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
	
	Signal = CheckSignal(false, SignalID);//----    
   if(Signal != -1)	CloseAllOrders(Signal, SysID, ClrBuy, ClrSell);

	cbuy = CountAllOrders(OP_BUY, SysID); csell = CountAllOrders(OP_SELL, SysID); 
	//----  STOP
	if (cbuy<=0) {	total = CreatTicketArray(OP_SELLSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrSell);}
	if (csell<=0) { total = CreatTicketArray(OP_BUYSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], ClrBuy);}

	Signal = CheckSignal(true, SignalID);//----    
	if (Signal == -1) return; //        

   if(Signal==OP_BUY)//-----   
	{
		if (cbuy>0)	return; //----      ,    
		//----    STOP
		total = CreatTicketArray(OP_SELLSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Red);
		OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, "BUY", SysID, 0, ClrBuy);
		OrderSend(Symbol(), OP_SELLSTOP, lots, Ask-SysPar[SysID][_SL]*Point, 3, Ask, Ask-2*SysPar[SysID][_TP]*Point, "SELL", SysID, 0, ClrSell);
		return; 
	}
	if(Signal==OP_SELL)//-----   
	{
		if (csell>0)	return; //----      ,    
		//----    STOP
		total = CreatTicketArray(OP_BUYSTOP, SysID); for (i=1; i<=total; i++) OrderDelete(Ticket[i], Red);
		OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, "SELL", SysID, 0, ClrSell);
		OrderSend(Symbol(), OP_BUYSTOP, lots, Bid+SysPar[SysID][_SL]*Point, 3, Bid, Bid+2*SysPar[SysID][_TP]*Point, "BUY", SysID, 0, ClrSell);
		return;
	}
//----
}

void ProcessSimple(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
	double lots = AccountFreeMargin()*0.01*0.0001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
	
//----    
	Signal = CheckSignal(false, SignalID);
   if(Signal != -1)	TryCloseAllOrders(Signal, SysID, ClrBuy, ClrSell);

//----    
	cbuy = CountAllOrders(OP_BUY, SysID); csell = CountAllOrders(OP_SELL, SysID); 

	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
   if(Signal == OP_BUY)
	{
		if (cbuy>0)	return; //----      ,    
		//----    BUY
		ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-SysPar[SysID][_SL]*Point, Ask+SysPar[SysID][_TP]*Point, "BUY", SysID, 0, ClrBuy);
		if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
		return; 
	}

//-----   
	if(Signal == OP_SELL)
	{
		if (csell>0)	return; //----      ,    
		ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+SysPar[SysID][_SL]*Point, Bid-SysPar[SysID][_TP]*Point, "SELL", SysID, 0, ClrSell);
		if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
		return;
	}
//----
}

void ProcessMultiOpen(int SignalID, int SysID, color ClrBuy, color ClrSell)
{
	double lots = AccountFreeMargin()*0.01*0.0001; // 
	lots = NormalizeDouble(lots, LotDigit); //    
	if (MinLot>lots) lots = MinLot;//     
	
	int ticket, total, i, cbuy, csell, Signal;
//----      
	cbuy = CreatTicketArray(OP_BUY, SysID); csell = CreatTicketArray(OP_SELL, SysID); 
	
//----    
	Signal = CheckSignal(true, SignalID);
	if (Signal == -1) return; //        
	
//-----   
   if(Signal == OP_BUY)
		{
			if (cbuy>0)	//  
				for (i=1; i<=cbuy; i++)//     ,    
				{	OrderSelect(Ticket[i], SELECT_BY_TICKET); if (OrderOpenTime()>=Time[0]) return; } 
			//----    BUY
			ticket = OrderSend(Symbol(), OP_BUY, lots, Ask, 3, Ask-3000*Point, Ask+SysPar[SysID][_TP]*Point, "BUY", SysID, 0, ClrBuy);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return; 
		}
//-----    
	if(Signal == OP_SELL)
		{
			if (csell>0)	 for (i=1; i<=csell; i++) {	OrderSelect(Ticket[i], SELECT_BY_TICKET); if (OrderOpenTime()>=Time[0]) return; } 
			ticket = OrderSend(Symbol(), OP_SELL, lots, Bid, 3, Bid+3000*Point, Bid-SysPar[SysID][_TP]*Point, "SELL", SysID, 0, ClrSell);
			if (ticket==-1) { i=GetLastError();	Print("error(",i,"): ",ErrorDescription(i));}
			return;
     }
//----
}
int init()  
{   
	InitSystemParam(); 
	
	SysPar[SIDUS][_TP] = 900.0;//  
	SysPar[SIDUS][_NullTP] = 20.0;//  ,      
	SysPar[SIDUS][_TS] = 50.0; //    
	SysPar[SIDUS][_NullSL] = 15.0;// ,         
	SysPar[SIDUS][_SL] = 80;//   ,   BLACKSYS

	SysPar[BLACKSYS][_TP] = 1000.0;//  ,      
	SysPar[BLACKSYS][_NullTP] = 20.0;//  ,      
	SysPar[BLACKSYS][_TS] = 50.0; //    
	SysPar[BLACKSYS][_NullSL] = 20.0;// ,         
	SysPar[BLACKSYS][_SL] = 70;//   ,   BLACKSYS

	SysPar[BLACKSYS+1][_NullTP] = 20.0;//  ,      
	SysPar[BLACKSYS+1][_TS] = 50.0; //    
	SysPar[BLACKSYS+1][_NullSL] = 20.0;// ,         
	SysPar[BLACKSYS+1][_SL] = 8000;//   ,   BLACKSYS

	SysPar[SIDUSSAFE][_TP] = 100.0;//  ,      
	SysPar[SIDUSSAFE][_NullTP] = 15.0;//  ,      
	SysPar[SIDUSSAFE][_TS] = 45.0; //    
	SysPar[SIDUSSAFE][_NullSL] = 20.0;// ,         
	SysPar[SIDUSSAFE][_SL] = 65;//   ,   
	SysPar[SIDUSSAFE][_dSL] = 50;//         

	SysPar[SIDUSSINC][_TP] = 500.0;//  
	SysPar[SIDUSSINC][_NullTP] = 50.0;//  ,      
	SysPar[SIDUSSINC][_TS] = 50.0; //    
	SysPar[SIDUSSINC][_NullSL] = 40.0;// ,         
	SysPar[SIDUSSINC][_SL] = 70;//   ,   
	SysPar[SIDUSSINC][_dSL] = 50;//         

	SysPar[ENVELOP][_TP] = 2000.0;//  
	SysPar[ENVELOP][_NullTP] = 20.0;//  ,      
	SysPar[ENVELOP][_TS] = 40.0; //    
	SysPar[ENVELOP][_NullSL] = 20.0;// ,         
	SysPar[ENVELOP][_SL] = 70;//   ,   
	SysPar[ENVELOP][_dSL] = 35;//         

	SysPar[WPR][_TP] = 2000.0;//  
	SysPar[WPR][_NullTP] = 20.0;//  ,      
	SysPar[WPR][_TS] = 80.0; //    
	SysPar[WPR][_NullSL] = 20.0;// ,         
	SysPar[WPR][_SL] = 70;//   ,   
	SysPar[WPR][_dSL] = 35;//         

	SysPar[VEGAS1H][_TP] = 55.0;//  
	SysPar[VEGAS1H][_NullTP] = 20.0;//  ,      
	SysPar[VEGAS1H][_TS] = 60.0; //    
	SysPar[VEGAS1H][_NullSL] = 70.0;// ,         
	SysPar[VEGAS1H][_SL] = 70;//   ,   

	SysPar[VEGAS1H+1][_TP] = 89.0;//  
	SysPar[VEGAS1H+1][_NullTP] = 55.0;//  ,      
	SysPar[VEGAS1H+1][_TS] = 144.0; //    
	SysPar[VEGAS1H+1][_NullSL] = 70.0;// ,         
	SysPar[VEGAS1H+1][_SL] = 70;//   ,   

	SysPar[VEGAS1H+2][_TP] = 2000.0;//  
	SysPar[VEGAS1H+2][_NullTP] = 144.0;//  ,      
	SysPar[VEGAS1H+2][_TS] = 235.0; //    
	SysPar[VEGAS1H+2][_NullSL] = 70.0;// ,         
	SysPar[VEGAS1H+2][_SL] = 70;//   ,   

	SysPar[CSPLINE][_TP] = 180.0;//   
	SysPar[CSPLINE][_NullTP] = 30.0;//  ,      
	SysPar[CSPLINE][_TS] = 50.0; //    
	SysPar[CSPLINE][_NullSL] = 70.0;// ,         
	SysPar[CSPLINE][_SL] = 45;//   ,   

	SysPar[MACROSS3][_TP] = 200.0;//   
	SysPar[MACROSS3][_NullTP] = 30.0;//  ,      
	SysPar[MACROSS3][_TS] = 50.0; //    
	SysPar[MACROSS3][_NullSL] = 70.0;// ,         
	SysPar[MACROSS3][_SL] = 45;//   ,   

	SysPar[KRIVETKA][_TP] = 1000.0;//   
	SysPar[KRIVETKA][_NullTP] = 100.0;//  ,      
	SysPar[KRIVETKA][_TS] = 150.0; //    
	SysPar[KRIVETKA][_NullSL] = 210.0;// ,         
	SysPar[KRIVETKA][_SL] = 450;//   ,   
	SysPar[KRIVETKA][_dSL] = 50;//   ,   

	SysPar[BORCHAN][_TP] = 1000.0;//   
	SysPar[BORCHAN][_NullTP] = 50.0;//  ,      
	SysPar[BORCHAN][_TS] = 50.0; //    
	SysPar[BORCHAN][_NullSL] = 210.0;// ,         
	SysPar[BORCHAN][_SL] = 57;//   ,   

	SysPar[FORCE][_TP] = 1000.0;//   
	SysPar[FORCE][_NullTP] = 40.0;//  ,      
	SysPar[FORCE][_NullTP2] = 20.0;//  ,      
	SysPar[FORCE][_TS] = 50.0; //    
	SysPar[FORCE][_NullSL] = 50.0;// ,         
	SysPar[FORCE][_SL] = 50;//   ,   
	SysPar[FORCE][_dSL] = 40;//   ,   

//	HideTestIndicators(true);
	
	return(0);  
}
int deinit()  {  	HideTestIndicators(false); return(0);  }

void start()
{
//----     
//   if(IsTradeAllowed()==false) {Comment("!!!! !!!!!"); return; }
//	ProcessAvg(SIDUSSINC, Green, Red);	TrailingAvg(SIDUSSINC, Green, Red);
//	ProcessSimple(SIDUSSINC, Green, Red);	TrailingSimple(SIDUSSINC, Green, Red);
//	ProcessSimple(SIDUSSAFE, SIDUSSAFE, Green, Red);	TrailingSimple(SIDUSSAFE, Green, Red);
//	ProcessAvg(VEGAS4H, SkyBlue, Wheat);	TrailingAvg(VEGAS4H, SkyBlue, Wheat);
//	ProcessMultiOpen(MACROSS, MACROSS, Green, Red); TrailingMultiOpen(MACROSS, Green, Red);
//	ProcessSimple(SIDUS, SIDUS, Green, Red);	TrailingSimple(SIDUS, Green, Red);// 1
//	ProcessAvg(WPR, WPR, Green, Red);	TrailingAvg(WPR, Green, Red);
//	ProcessAvg(ENVELOP2, ENVELOP2, Green, Red);	TrailingAvg(ENVELOP2, Green, Red);
//	ProcessSimple(VEGAS1H, VEGAS1H, Green, Red);	TrailingSimple(VEGAS1H, Green, Red);
//	ProcessSimple(VEGAS1H, VEGAS1H+1, Green, Red);	TrailingSimple(VEGAS1H+1, Green, Red);
//	ProcessSimple(VEGAS1H, VEGAS1H+2, Green, Red);	TrailingSimple(VEGAS1H+2, Green, Red);
//	ProcessAvg(KORABLIK, KORABLIK, Green, Red);	TrailingAvg(KORABLIK, Green, Red);

/* */
//	ProcessAvg(FORCE, FORCE, Green, Red);	TrailingAvg(FORCE, Green, Red);
//	ProcessAvg(ENVELOP, ENVELOP, Green, Red);	TrailingAvg(ENVELOP, Green, Red);
//	ProcessSimple(BLACKSYS, BLACKSYS, Green, Red);	TrailingSimple(BLACKSYS, Green, Red);//  4
//	ProcessSimple(MACROSS3, MACROSS3, Green, Red);	TrailingSimple(MACROSS3, Green, Red);//

/**/
//	ProcessTurn(BORCHAN, BORCHAN, Green, Red);	TrailingSimple(BORCHAN, Green, Red);
//	ProcessSimple(KRIVETKA, KRIVETKA, Green, Red);	TrailingSimple(KRIVETKA, Green, Red);//
//	ProcessSimple(CSPLINE, CSPLINE, Green, Red);	TrailingSimple(CSPLINE, Green, Red);//
//	ProcessSimple(MACD, MACD, Black, Plum);	TrailingSimple(MACD, Black, Plum);
//	ProcessAvg(BLACKSYS, BLACKSYS+1, Green, Red);	TrailingAvg(BLACKSYS+1, Green, Red); //
//	ProcessAvg(BUYFOREVE, BUYFOREVE, Black, Plum);	TrailingAvg(BUYFOREVE, Black, Plum);
//	ProcessAvg(SELLFOREVE,SELLFOREVE, SkyBlue, Wheat);	TrailingAvg(SELLFOREVE, SkyBlue, Wheat);

}
//+------------------------------------------------------------------+